#pragma once
#include "IHashTable.h"
#include <vector>

template <typename Type>
class LPHashTable : public IHashTable<Type>
{
public:
	LPHashTable(int estimatedNumberOfElementsToBePlaceInTable);
	virtual unsigned int hash(const std::string& key) const;
	virtual bool contains(const std::string& key) const;
	virtual Type lookup(const std::string& key) const;
	virtual void insert(const std::string& key, const Type& thingToInsert);
	virtual int getNCollisions() const;
	virtual ~LPHashTable();
private:
	std::vector<Type> table_;
};

template <typename Type>
LPHashTable<Type>::LPHashTable(int estimatedElementsToBePlacedInTable) :
	table_(1)
{
}

template <typename Type>
LPHashTable<Type>::~LPHashTable()
{
}

template <typename Type>
unsigned int LPHashTable<Type>::hash(const std::string& key) const
{
	return 0;
}

template <typename Type>
bool LPHashTable<Type>::contains(const std::string& key) const
{
	return false;
}

template <typename Type>
void LPHashTable<Type>::insert(const std::string& key, const Type& thingToInsert)
{
}

template <typename Type>
Type LPHashTable<Type>::lookup(const std::string& key) const
{
	Type myType = 1;
	return myType;
}

template <typename Type>
int LPHashTable<Type>::getNCollisions() const
{
	return 0;
}

